"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DetailsBlockProvider = DetailsBlockProvider;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _core() {
  const data = require("@formily/core");
  _core = function _core() {
    return data;
  };
  return data;
}
function _react2() {
  const data = require("@formily/react");
  _react2 = function _react2() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _FlowContext = require("../../FlowContext");
function _client2() {
  const data = require("@nocobase/utils/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function useFlowContextData(dataSource) {
  const _useFlowContext = (0, _FlowContext.useFlowContext)(),
    execution = _useFlowContext.execution;
  const data = (0, _react().useMemo)(() => {
    var _execution$jobs;
    return {
      $context: execution === null || execution === void 0 ? void 0 : execution.context,
      $jobsMapByNodeId: ((_execution$jobs = execution === null || execution === void 0 ? void 0 : execution.jobs) !== null && _execution$jobs !== void 0 ? _execution$jobs : []).reduce((map, job) => Object.assign(map, {
        [job.nodeId]: job.result
      }), {})
    };
  }, [execution]);
  const result = (0, _react().useMemo)(() => (0, _client2().parse)(dataSource)(data), [execution]);
  return result;
}
function DetailsBlockProvider(props) {
  const field = (0, _react2().useField)();
  const formBlockRef = (0, _react().useRef)(null);
  const _useAssociationNames = (0, _client().useAssociationNames)(),
    appends = _useAssociationNames.appends,
    updateAssociationValues = _useAssociationNames.updateAssociationValues;
  const values = useFlowContextData(props.dataSource);
  const form = (0, _react().useMemo)(() => (0, _core().createForm)({
    values,
    readPretty: true
  }), [values]);
  const params = {
    appends
  };
  const service = {
    loading: false,
    data: {
      data: values
    }
  };
  const api = (0, _client().useAPIClient)();
  const resource = api.resource(props.collection);
  const __parent = (0, _react().useContext)(_client().BlockRequestContext);
  return _react().default.createElement(_client().CollectionProvider, {
    collection: props.collection
  }, _react().default.createElement(_client().RecordProvider, {
    record: values,
    parent: false
  }, _react().default.createElement(_client().BlockRequestContext.Provider, {
    value: {
      block: 'form',
      field,
      service,
      resource,
      __parent
    }
  }, _react().default.createElement(_client().FormBlockContext.Provider, {
    value: {
      params,
      form,
      field,
      service,
      updateAssociationValues,
      formBlockRef
    }
  }, props.children))));
}