"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _locale = require("../../../locale");
var _utils = require("../utils");
var _FormBlockInitializer = require("../FormBlockInitializer");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function CreateFormDesigner() {
  const _useCollection = (0, _client().useCollection)(),
    name = _useCollection.name,
    title = _useCollection.title;
  return _react().default.createElement(_client().GeneralSchemaDesigner, {
    title: title || name
  }, _react().default.createElement(_client().SchemaSettings.BlockTitleItem, null), _react().default.createElement(_client().SchemaSettings.LinkageRules, {
    collectionName: name
  }), _react().default.createElement(_client().SchemaSettings.DataTemplates, {
    collectionName: name
  }), _react().default.createElement(_client().SchemaSettings.Divider, null), _react().default.createElement(_client().SchemaSettings.Remove, {
    removeParentsIfNoChildren: true,
    breakRemoveOn: {
      'x-component': 'Grid'
    }
  }));
}
var _default = {
  title: `{{t("Create record form", { ns: "${_locale.NAMESPACE}" })}}`,
  config: {
    useInitializer() {
      const _useCollectionManager = (0, _client().useCollectionManager)(),
        collections = _useCollectionManager.collections;
      return {
        key: 'createRecordForm',
        type: 'subMenu',
        title: `{{t("Create record form", { ns: "${_locale.NAMESPACE}" })}}`,
        children: collections.filter(item => !item.hidden).map(item => ({
          key: `createForm-${item.name}`,
          type: 'item',
          title: item.title,
          schema: {
            collection: item.name,
            title: `{{t("Create record", { ns: "${_locale.NAMESPACE}" })}}`,
            formType: 'create',
            'x-designer': 'CreateFormDesigner'
          },
          component: _FormBlockInitializer.FormBlockInitializer
        }))
      };
    },
    initializers: {
      // AddCustomFormField
    },
    components: {
      CreateFormDesigner
    },
    parseFormOptions(root) {
      const forms = {};
      const formBlocks = (0, _utils.findSchema)(root, item => item['x-decorator'] === 'FormBlockProvider' && item['x-decorator-props'].formType === 'create');
      formBlocks.forEach(formBlock => {
        var _formBlock$xComponen;
        const _Object$keys = Object.keys(formBlock.properties),
          _Object$keys2 = _slicedToArray(_Object$keys, 1),
          formKey = _Object$keys2[0];
        const formSchema = formBlock.properties[formKey];
        forms[formKey] = {
          type: 'create',
          title: ((_formBlock$xComponen = formBlock['x-component-props']) === null || _formBlock$xComponen === void 0 ? void 0 : _formBlock$xComponen.title) || formKey,
          actions: (0, _utils.findSchema)(formSchema.properties.actions, item => item['x-component'] === 'Action').map(item => item['x-decorator-props'].value),
          collection: formBlock['x-decorator-props'].collection
        };
      });
      return forms;
    }
  },
  block: {
    scope: {
      // useFormBlockProps
    },
    components: {}
  }
};
exports.default = _default;